"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlFieldCode = void 0;
var react_1 = __importStar(require("react"));
var react_2 = require("@tiptap/react");
var select_1 = __importDefault(require("primeobjects-ui-web-application/build/cjs/controls/antd/select"));
var select_option_1 = __importDefault(require("primeobjects-ui-web-application/build/cjs/controls/antd/select-option"));
var lodash_1 = require("lodash");
var HtmlFieldCode = function (props) {
    var _a, _b;
    var node = props.node, updateAttributes = props.updateAttributes, extension = props.extension, readonly = props.readonly;
    var defaultValue = "javascript";
    var _c = (0, react_1.useState)(((_a = node === null || node === void 0 ? void 0 : node.attrs) === null || _a === void 0 ? void 0 : _a.language) ? (_b = node === null || node === void 0 ? void 0 : node.attrs) === null || _b === void 0 ? void 0 : _b.language : defaultValue), value = _c[0], setValue = _c[1];
    var langs = extension.options.lowlight.listLanguages();
    var renderOptions = function () {
        return (0, lodash_1.map)(langs, function (lang, index) {
            return (react_1.default.createElement(select_option_1.default, { key: index, value: lang }, lang));
        });
    };
    var onChange = function (newValue) {
        if ((0, lodash_1.find)(langs, function (l) { return l == newValue; })) {
            setValue(newValue);
            updateAttributes({ language: newValue });
        }
        else {
            setValue(defaultValue);
            updateAttributes({ language: defaultValue });
        }
    };
    var getCurrentLang = function () {
        var cur = (0, lodash_1.find)(langs, function (l) { return l == value; });
        return cur ? cur : "undefined";
    };
    return (react_1.default.createElement(react_2.NodeViewWrapper, { className: "code-block" },
        readonly ? (react_1.default.createElement("div", { className: "code-block-lang readonly" }, getCurrentLang())) : (react_1.default.createElement(select_1.default, { showSearch: true, className: "code-block-lang", defaultValue: defaultValue, onChange: onChange, value: value }, renderOptions())),
        react_1.default.createElement("pre", null,
            react_1.default.createElement(react_2.NodeViewContent, { as: "code" }))));
};
exports.HtmlFieldCode = HtmlFieldCode;
exports.default = exports.HtmlFieldCode;
//# sourceMappingURL=html-code.js.map